#include<bits/stdc++.h>


using namespace std;

bool is_pal(vector<long long> &inp_2, vector<long long> &inp_1, long long i, long long j, long long x, long long y) {
    if (i >= j) {
        return true;
    } else if (inp_2[i] + inp_1[x] == inp_2[j] + inp_1[y]) {
        return is_pal(inp_2, inp_1, i + 1, j - 1, x + 1, y - 1);
    } else {
        return false;
    }
}

bool is_pal_2(vector<long long> &inp, long long i, long long j) {
    if (i >= j) {
        return true;
    } else if (inp[i] == inp[j]) {
        return is_pal_2(inp, i + 1, j - 1);
    } else {
        return false;
    }
}

long long count_of_poly(vector<long long> &inp_1, vector<long long> &inp_2) {
    long long k = 0;
    for (long long i = 0; i < inp_2.size(); i++) {
        for (long long j = inp_2.size() - 1; j >= i; j--) {
            for (long long x = 0; x + j - i < inp_1.size(); x++) {
                long long y = x + j - i;
                if (is_pal(inp_2, inp_1, i, j, x, y)) {
                    k = max(k, j - i + 1);
                }
            }
        }
    }
    return k;
}


long long count_of_poly_2(vector<long long> &inp) {
    long long k = 0;
    for (long long i = 0; i < inp.size(); i++) {
        for (long long j = inp.size() - 1; j >= i; j--) {
            if (is_pal_2(inp, i, j)) {
                k = max(k, j - i + 1);
            }
        }
    }
    return k;
}


signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    long long n;
//    cin >> n;
//    long long f;
//    cin >> f;
//    vector<long long> inp(n);
//    long long max_mod = 1e9;
//    if (f == 1){
//        for (long long i = 0; i < n; i++){
//            cin >> inp[i];
//        }
//    } else {
//        long long m, x, y, z;
//        cin >> m >> x >> y >> z;
//        vector<long long> inp_not(m);
//        for (long long i = 0; i < m; i++){
//            cin >> inp_not[i];
//        }
//        for (long long i = 0; i < n; i++){
//            if (0 <= i <= m - 1){
//                inp[i] = inp_not[i];
//            } else {
//                inp[i] = ((x * inp[i - 2] + y * inp[i - 1] + z) % max_mod) + 1;
//            }
//        }
//    }
//    vector<long long> pref_sum(n);
//    for (long long i = 0; i < n; i++){
//        if (i == 0){
//            pref_sum[i] == inp[i];
//        } else {
//            pref_sum[i] = inp[i] + pref_sum[i - 1];
//        }
//    }
    long long n, m;
    cin >> n >> m;
    vector<long long> inp_1(max(n, m)), inp_2(min(n, m));
    bool flag = true;
    if (n >= m) {
        for (long long i = 0; i < n; i++) {
            cin >> inp_1[i];
        }
        for (long long i = 0; i < m; i++) {
            cin >> inp_2[i];
            if (i != 0 && inp_2[i] != inp_2[i - 1]) {
                flag = false;
            }
        }
    } else {
        for (long long i = 0; i < n; i++) {
            cin >> inp_2[i];
        }
        for (long long i = 0; i < m; i++) {
            cin >> inp_1[i];
            if (i != 0 && inp_1[i] != inp_1[i - 1]) {
                flag = false;
            }
        }
    }
    if (!flag) {
        cout << count_of_poly(inp_1, inp_2);
    } else {
        if (inp_1.size() == m) {
            cout << min(m, count_of_poly_2(inp_2));
        } else {
            cout << min(m, count_of_poly_2(inp_1));
        }
    }
    return 0;
}
//5 6
//4 3 3 2 1
//4 1 5 1 3 2